// generated by ../deps/sqlpp11/scripts/ddl2cpp types.sqlpp11.sql types wee
#ifndef WEE_TYPES_H
#define WEE_TYPES_H

#include <sqlpp11/table.h>
#include <sqlpp11/data_types.h>
#include <sqlpp11/char_sequence.h>

namespace wee
{
  namespace Types_
  {
    struct Id
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "id";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T id;
            T& operator()() { return id; }
            const T& operator()() const { return id; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::must_not_insert, sqlpp::tag::must_not_update>;
    };
    struct Name
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "name";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T name;
            T& operator()() { return name; }
            const T& operator()() const { return name; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::require_insert>;
    };
    struct Label
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "label";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T label;
            T& operator()() { return label; }
            const T& operator()() const { return label; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::require_insert>;
    };
    struct Project
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "project";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T project;
            T& operator()() { return project; }
            const T& operator()() const { return project; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Properties
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "properties";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T properties;
            T& operator()() { return properties; }
            const T& operator()() const { return properties; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::can_be_null>;
    };
  } // namespace Types_

  struct Types: sqlpp::table_t<Types,
               Types_::Id,
               Types_::Name,
               Types_::Label,
               Types_::Project,
               Types_::Properties>
  {
    struct _alias_t
    {
      static constexpr const char _literal[] =  "types";
      using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
      template<typename T>
      struct _member_t
      {
        T types;
        T& operator()() { return types; }
        const T& operator()() const { return types; }
      };
    };
  };
} // namespace wee
#endif
